<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for services StructType
 * @subpackage Structs
 */
class Services extends AbstractStructBase
{
    /**
     * The service
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var Service[]
     */
    public $service;
    /**
     * Constructor method for services
     * @uses Services::setService()
     * @param Service[] $service
     */
    public function __construct(array $service = array())
    {
        $this
            ->setService($service);
    }
    /**
     * Get service value
     * @return Service[]|null
     */
    public function getService()
    {
        return $this->service;
    }
    /**
     * This method is responsible for validating the values passed to the setService method
     * This method is willingly generated in order to preserve the one-line inline validation within the setService method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceForArrayConstraintsFromSetService(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $servicesServiceItem) {
            // validation for constraint: itemType
            if (!$servicesServiceItem instanceof Service) {
                $invalidValues[] = is_object($servicesServiceItem) ? get_class($servicesServiceItem) : sprintf('%s(%s)', gettype($servicesServiceItem), var_export($servicesServiceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The service property can only contain items of type Service, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set service value
     * @throws \InvalidArgumentException
     * @param Service[] $service
     * @return Services
     */
    public function setService(array $service = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceArrayErrorMessage = self::validateServiceForArrayConstraintsFromSetService($service))) {
            throw new \InvalidArgumentException($serviceArrayErrorMessage, __LINE__);
        }
        $this->service = $service;
        return $this;
    }
    /**
     * Add item to service value
     * @throws \InvalidArgumentException
     * @param Service $item
     * @return Services
     */
    public function addToService(Service $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof Service) {
            throw new \InvalidArgumentException(sprintf('The service property can only contain items of type Service, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->service[] = $item;
        return $this;
    }
}
